/*
 * silkworm85xx.h
 *
 * Based on:
 * arch/ppc/platforms/85xx/mpc85xx_cds_common.h
 *
 * Copyright (c) 2008-2009 Brocade Communications Systems, Inc.
 * All rights reserved.
 *
 * Description:
 * Brocade Silkworm85xx platform specific definitions
 * This file is only used by FABOS for any specific
 * 85xx definitions not found in current version of
 * the kernel include files.
 * Linux kernel shall never use this file !!!
 */

#ifndef __MACH_SILKWORM85xx_H__
#define __MACH_SILKWORM85xx_H__

#define MPC85xx_GUTS_SIZE (0x01000)
#define MPC85xx_GUTS_OFFSET (0xe0000)

/* originally from immap_85xx.h */
/* Global Utility Registers */
typedef struct ccsr_guts {
	uint	porpllsr;	/* 0x.0000 - POR PLL Ratio Status Register */
	uint	porbmsr;	/* 0x.0004 - POR Boot Mode Status Register */
	uint	porimpscr;	/* 0x.0008 - POR I/O Impedance Status and Control Register */
	uint	pordevsr;	/* 0x.000c - POR I/O Device Status Register */
	uint	pordbgmsr;	/* 0x.0010 - POR Debug Mode Status Register */
	char	res1[12];
	uint	gpporcr;	/* 0x.0020 - General-Purpose POR Configuration Register */
	char	res2[12];
	uint	gpiocr;		/* 0x.0030 - GPIO Control Register */
	char	res3[12];
	uint	gpoutdr;	/* 0x.0040 - General-Purpose Output Data Register */
	char	res4[12];
	uint	gpindr;		/* 0x.0050 - General-Purpose Input Data Register */
	char	res5[12];
	uint	pmuxcr;		/* 0x.0060 - Alternate Function Signal Multiplex Control */
	char	res6[12];
	uint	devdisr;	/* 0x.0070 - Device Disable Control */
	char	res7[12];
	uint	powmgtcsr;	/* 0x.0080 - Power Management Status and Control Register */
	char	res8[12];
	uint	mcpsumr;	/* 0x.0090 - Machine Check Summary Register */
	char	res9[12];
	uint	pvr;		/* 0x.00a0 - Processor Version Register */
	uint	svr;		/* 0x.00a4 - System Version Register */
	char	res10[3416];
	uint	clkocr;		/* 0x.0e00 - Clock Out Select Register */
	char	res11[12];
	uint	ddrdllcr;	/* 0x.0e10 - DDR DLL Control Register */
	char	res12[12];
	uint	lbcdllcr;	/* 0x.0e20 - LBC DLL Control Register */
	char	res13[61916];
} ccsr_guts_t;

#define MPC85xx_OPENPIC_OFFSET (0x40000)

#define MPC85XX_PEX_COCPU_LOWER_MEM		0x80000000
#define PCI1_CFG_ADDR_OFFSET	(0x8000)

/* The 12 external interrupt lines */
#define MPC85xx_IRQ_EXT0		0
#define MPC85xx_IRQ_EXT1		1
#define MPC85xx_IRQ_EXT2		2
#define MPC85xx_IRQ_EXT3		3
#define MPC85xx_IRQ_EXT4		4
#define MPC85xx_IRQ_EXT5		5
#define MPC85xx_IRQ_EXT6		6
#define MPC85xx_IRQ_EXT7		7
#define MPC85xx_IRQ_EXT8		8
#define MPC85xx_IRQ_EXT9		9
#define MPC85xx_IRQ_EXT10		10
#define MPC85xx_IRQ_EXT11		11

/* exception is made to avoid FOS include fsl_soc.h */
extern phys_addr_t get_immrbase(void);

#endif /* __MACH_SILKWORM85xx_H__ */
