/*
 *
 *    Copyright (c) 2007 Brocade Communications Systems, Inc.
 *    All rights reserved.
 *
 *    Description:
 * 		Definitions for Silkworm I2C performance statistics
 *
 */

#ifndef __I2C_STATS_H__
#define __I2C_STATS_H__

#if 0
#define PERF_TIME_DIFF(begin, end, diff)	\
	(diff) = ((((end).tv_sec) == ((begin).tv_sec)) ?	\
	(((end).tv_usec) - ((begin).tv_usec)) :		\
	(1000000 - ((begin).tv_usec) + ((end).tv_usec)))
#endif

#define PERF_TIME_DIFF_PTR(begin, end, diff)	\
	(diff) = ((((end)->tv_sec) == ((begin)->tv_sec)) ?	\
	(((end)->tv_usec) - ((begin)->tv_usec)) :		\
	(1000000 - ((begin)->tv_usec) + ((end)->tv_usec)))


#define PERF_STATS_UPDATE(value, ptr) \
	(ptr)->sum += (value); \
	if ((value) > (ptr)->max) { \
		(ptr)->max = (value); \
	} \
	if ((((ptr)->min) == 0)|| \
		((value) < (ptr)->min)) { \
		(ptr)->min = (value); \
	}


/* I2C performance statistics. */

typedef struct perf_debug_stats {
	u_long min;
	u_long max;
	u_long sum;
	u_int count;
} perf_debug_stats_t;


/* i2c related statistic counters */
typedef struct i2c_perf_stats {

	perf_debug_stats_t read_xfers;
	perf_debug_stats_t read_bytes;

	perf_debug_stats_t write_xfers;
	perf_debug_stats_t write_bytes;

	perf_debug_stats_t wait_times;
	perf_debug_stats_t clients;

	perf_debug_stats_t error_times;

	perf_debug_stats_t arb_times;
	perf_debug_stats_t arb_loops;

	perf_debug_stats_t intr_times;

} i2c_perf_stats_t;

extern i2c_perf_stats_t i2c_perf, *perf_stats;

extern int perf_stats_show(char *buf, char **start, off_t pos,
						   int count, int *eof,	void *data);
extern int perf_stats_write(struct file *file, const char *buffer,
							unsigned long count, void *data);
extern void perf_stats_init(void);

extern void perf_stats_xfer_begin(perf_debug_stats_t *xfers,
								  perf_debug_stats_t *bytes,
								  struct timeval *perf_begin, int length);
extern void perf_stats_xfer_end(perf_debug_stats_t *xfers,
								struct timeval *perf_begin);

#endif /* __I2C_STATS_H__ */
