/*
 * Brocade platform support for all the Silkworm products
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 or the License, or (at your
 * option) any later version.
 */

#ifdef __KERNEL__
#ifndef __SILKWORM_FEATURES_H_
#define __SILKWORM_FEATURES_H_

typedef int (*feature_call)(int param, int value);

typedef struct _feature_table_entry {
    unsigned int    selector;
    feature_call    function;
} silkworm_feature_tbe_t;

/* SILK_FTR_GET_MEM_HOLE
 *
 * Returns back 
 */
#define SILKWORM_FTR_GET_MEM_HOLE	0x1

typedef struct _silkworm_mem_hole {
	unsigned int offset;
	unsigned int size;
} silkworm_mem_hole_t; 

typedef struct _silkworm_mb_def
{
    const char	*model_string;
    const char	*model_name;
    struct sw_bd    *silkworm;
    silkworm_feature_tbe_t	*features;
} silkworm_mb_def_t;

extern silkworm_mb_def_t silkworm_mb;

extern long ppc44x_do_feature_call(unsigned int selector, ...);

#endif /* __SILKWORM_FEATURES_H_ */
#endif /* __KERNEL__ */
