/*
 * Copyright (C) 2014 Brocade Communications Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 * silkworm_pcie.h
 *
 * Definitions specific to Brocade PCIe code.
 *
 */

#include <linux/types.h>
#include <linux/version.h>
#include <linux/pci.h>

#ifndef __SILKWORM_PCIE_H__
#define __SILKWORM_PCIE_H__

void hotplug_fixup_resources(struct pci_dev *dev);
int find_pci_of_resources(struct pci_dev *dev, u32 *memory, u32 *busses);
int pex8632_errata_port_reset(struct pci_dev *dev, int speed);
int pex8614_errata_port_reset(struct pci_dev *dev, int speed);
int pex_get_port_type(struct pci_dev *dev);


#endif /* __SILKWORM_PCIE_H__ */

