#ifndef _WM_DUMPER_H
#define _WM_DUMPER_H

#include <linux/ioctl.h>
#define WM_DUMPER_MAGIC                ('a')
#define WM_DUMPER_IOC_MAP		_IOW(WM_DUMPER_MAGIC, 1, struct client_info)
#define WM_DUMPER_IOC_FREE		_IOW(WM_DUMPER_MAGIC, 2, unsigned int)
#define WM_DUMPER_IOC_DETACH            _IOW(WM_DUMPER_MAGIC, 3, int)

struct	client_info{
	char filename [256]; 
	int map_id;
	int size;	/* bytes) */ 
}; 

// Client ids
#define WM_DUMPER_MAP_ID_TRACE 0
#define WM_DUMPER_MAP_ID_PANIC_DUMP 1
#define WM_DUMPER_MAP_ID_RB_REASON 2
#define WM_DUMPER_MAP_ID_MODULE_NAMES 3
#define WM_DUMPER_MAX_CLIENTS 3

#define PANIC_CHUNK 0
#define TRACE_CHUNK 1

#ifdef WMD
// mb_map contains client id to chunk mapping
// To add a new client, associate the client with corresponding chunk in this array
static int mb_map[] = { TRACE_CHUNK, PANIC_CHUNK, PANIC_CHUNK, PANIC_CHUNK }; 
#endif /* WMD */

int wm_map_file (char *path, int id);

#ifdef __KERNEL__

int wm_dump_write(int handle, int client_id, char *buf, int size);
int wm_dump_read(int handle, int client_id, char *buf, int size);
int wm_dump_open(int client_id);
int wm_dump_close(int handle, int client_id);

#endif /* __KERNEL__ */

#endif /* !(_WM_DUMPER_H) */
