
#ifdef CONFIG_SILKWORM_WMAP

#define BYTES_PER_MB 1048576

/* To add new modules for warm memory, 
 * add chunk ID in the enum array below. Also, add a new element to shared_chunks or unshared_chunksarray in wmap.c
 */

enum {
    WMAP_PANIC_DUMP=0,
    WMAP_TRACE_BUFFER,
#ifdef CONFIG_SILKWORM_WMAP_DEBUG
    WMAP_UNSHARED_TEST_MODULE,
#endif
    MAX_UNSHARED_CHUNK_ID
};

enum {
    WMAP_WMEM=0,
#ifdef CONFIG_GTG_ENET
    WMAP_GTG_ENET,
#endif
#ifdef CONFIG_SILKWORM_WMAP_DEBUG
    WMAP_SHARED_TEST_MODULE,
#endif
/*Place allways platform  as last entry*/
    WMAP_PLATFORM,
    MAX_SHARED_CHUNK_ID
};

extern void WMAP_init(void);
#if 0
extern unsigned int WMAP_get_shared_seg_size(void);
#endif
extern unsigned int WMAP_get_unshared_seg_size(void);
extern unsigned int WMAP_get_unshared_chunk_range(unsigned int chunkID, void **start_addr, int *chunk_size);
extern unsigned int WMAP_get_shared_chunk_range(unsigned int chunkID, void **start_addr, int *chunk_size);

enum {
    WMAP_SUCCESS=0,
    WMAP_UNINITIALIZED,
    WMAP_BAD_CHUNK_ID
};


#endif

